/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2000, 2010 Oracle and/or its affiliates.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

#ifndef SC_ADDINCFG_HXX
#define SC_ADDINCFG_HXX

#include <unotools/configitem.hxx>

class ScAddInCfg : public utl::ConfigItem
{
    com::sun::star::uno::Sequence<rtl::OUString> GetPropertyNames();

public:
            ScAddInCfg();

    virtual void	Notify( const com::sun::star::uno::Sequence<rtl::OUString>& aPropertyNames );
    virtual void	Commit();

    com::sun::star::uno::Sequence< com::sun::star::uno::Any>
            GetProperties(const com::sun::star::uno::Sequence< rtl::OUString >& rNames)
                            { return ConfigItem::GetProperties( rNames ); }

    using ConfigItem::GetNodeNames;

//	com::sun::star::uno::Sequence< rtl::OUString > GetNodeNames(rtl::OUString& rNode)
//							{ return ConfigItem::GetNodeNames( rNode ); }
};


#endif

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
